import sys
import time
import os
import email.Parser
import imp

from Bouncers import BouncerAPI

import publisher

from qommon.tokens import Token
from qommon.bounces import Bounce

COMMA_SPACE = ', '

def process_bounce(args):
    try:
        parser = email.Parser.Parser()
        bouncers_dir = os.path.join(os.path.dirname(__file__), 'Bouncers')
        sys.path.append(bouncers_dir)
        msg = parser.parse(sys.stdin)
        for modname in BouncerAPI.BOUNCE_PIPELINE:
            __import__(modname)
            addrs = sys.modules[modname].process(msg)
            if addrs is BouncerAPI.Stop:
                return # Stop means to ignore message
            if addrs:
                break
        else:
            return # didn't find any match

        try:
            to = msg['To']
            local_part, server_part = to.split('@')
            token_id = local_part.split('+')[1]
        except (IndexError, KeyError):
            return

        pub = publisher.WcsPublisher.create_publisher()
        pub.app_dir = os.path.join(pub.app_dir, server_part)

        try:
            token = Token.get(token_id)
        except KeyError:
            return

        if token.type != 'email-bounce':
            return

        token.remove_self()

        bounce = Bounce()
        bounce.arrival_time = time.time()
        bounce.bounce_message = msg.as_string()
        bounce.addrs = addrs
        bounce.original_message = token.email_message
        bounce.original_rcpts = token.email_rcpts
        bounce.email_type = token.email_type
        bounce.store()
    except Exception, e:
        import traceback
        file('/tmp/bounces-error', 'a+').write(traceback.format_exc())
        sys.exit(1)

