import socket
import sys
import qommon.scgi_server
import quixote.server.simple_server

import publisher

def start(args):
    run_kwargs = {}
    run_kwargs['port'] = 3001
    run_kwargs['spawn_cron'] = True
    run_function = qommon.scgi_server.run

    i = 0
    while i < len(args):
        if args[i] == '--port':
            run_kwargs['port'] = int(args[i+1])
            i += 1
        elif args[i] == '--extra':
            publisher.WcsPublisher.register_extra_dir(args[i+1])
            i += 1
        elif args[i] == '--script-name':
            run_kwargs['script_name'] = args[i+1]
            i += 1
        elif args[i] == '--app-dir':
            publisher.WcsPublisher.APP_DIR = args[i+1]
            i += 1
        elif args[i] == '--data-dir':
            publisher.WcsPublisher.DATA_DIR = args[i+1]
            i += 1
        elif args[i] == '--http':
            del run_kwargs['spawn_cron']
            run_function = quixote.server.simple_server.run
        i += 1

    try:
        run_function(publisher.WcsPublisher.create_publisher, **run_kwargs)
    except socket.error, e:
        if e[0] == 98:
            print >> sys.stderr, 'address already in use'
            sys.exit(1)
        raise
    except KeyboardInterrupt:
        sys.exit(1)

