try:
    from quixote.ptl import compile_package
    compile_package(__path__)
except ImportError:
    pass
from quixote import get_publisher

import base

def login(method):
    m = get_publisher().ident_methods.get(method)
    if m and hasattr(m, 'login'):
        return m().login()
    return get_method_directory(method).login()

def register(method):
    return get_method_directory(method).register()

def get_method_directory(method):
    m = get_publisher().ident_methods.get(method)
    if not m:
        raise KeyError
    return m.method_directory()

def get_method_admin_directory(method):
    return get_publisher().ident_methods.get(method).method_admin_directory()

def get_method_classes():
    return get_publisher().ident_methods.values()

