import sys
import time
import fcntl
import os
import socket

from scgi import scgi_server

import quixote.server.scgi_server

import sessions
import cron


class QommonHandler(quixote.server.scgi_server.QuixoteHandler):
    def handle_connection(self, conn):
        quixote.server.scgi_server.QuixoteHandler.handle_connection(self, conn)
        # input, output and conn are closed, long running jobs could be done
        # here.
        self.publisher.response.process_after_jobs()


class SCGIServer(scgi_server.SCGIServer):
    def reap_children(self):
        while self.children:
            (pid, status) = os.waitpid(-1, os.WNOHANG)
            if pid <= 0:
                break
            try:
                os.close(self.children[pid])
            except KeyError:
                print >> sys.stderr, 'Closing connection to unknown pid:', pid
                continue
            del self.children[pid]


def run(create_publisher, host='localhost', port=3000, script_name=None,
        max_children = 5, spawn_cron = False):

    if spawn_cron:
        cron.spawn_cron(create_publisher)

    def create_handler(parent_fd):
        return QommonHandler(parent_fd, create_publisher, script_name)

    s = SCGIServer(create_handler, host=host, port=port,
                               max_children=max_children)
    s.serve()

