import random
import string

from qommon.storage import StorableObject
import time

class Token(StorableObject):
    _names = 'tokens'

    type = None
    expiration = None

    def __init__(self, expiration_delay = 86400):
        StorableObject.__init__(self)
        self.expiration = time.time() + expiration_delay

    def get_new_id(cls):
        keys = cls.keys()
        chars = list(string.digits + string.letters)
        while True:
            id = ''.join([random.choice(chars) for x in range(16)])
            if not id in keys:
                return id

    def migrate(self):
        if self.expiration < time.time():
            self.remove_self()
            raise KeyError()
