#! /usr/bin/env python

import sys

def print_usage():
    print 'Usage: wcsctl.py command [...]'
    print ''
    print 'Commands:'
    print '  start                start server'
    print '  clean_sessions       clean old sessions'
    print '  rebuild_indexes      rebuild database indexes'
    print '  export_settings      export settings'


if len(sys.argv) < 2:
    print_usage()
    sys.exit(1)
else:
    command = sys.argv[1]

    if command == 'start':
        from wcs.ctl.start import start
        start(sys.argv[2:])
    elif command == 'clean_sessions':
        from wcs.ctl.clean_sessions import clean_sessions
        clean_sessions(sys.argv[2:])
    elif command == 'rebuild_indexes':
        from wcs.ctl.rebuild_indexes import rebuild_indexes
        rebuild_indexes(sys.argv[2:])
    elif command == 'process_bounce':
        from wcs.ctl.process_bounce import process_bounce
        process_bounce(sys.argv[2:])
    elif command == 'export_settings':
        from wcs.ctl.export_settings import export_settings
        export_settings(sys.argv[2:])
    else:
        print_usage()

